/*!
 * 
 * handler-fragment v1.0.10
 * Copyright 2021-present.
 * All rights reserved.
 *       
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("React"), require("ReactDOM"));
	else if(typeof define === 'function' && define.amd)
		define(["React", "ReactDOM"], factory);
	else if(typeof exports === 'object')
		exports["HandlerFragment"] = factory(require("React"), require("ReactDOM"));
	else
		root["HandlerFragment"] = factory(root["React"], root["ReactDOM"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__0__, __WEBPACK_EXTERNAL_MODULE__4__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 17);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__0__;

/***/ }),
/* 1 */
/***/ (function(module, exports) {

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

module.exports = _defineProperty;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 2 */
/***/ (function(module, exports) {

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

module.exports = _classCallCheck;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 3 */
/***/ (function(module, exports) {

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

module.exports = _createClass;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__4__;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

var arrayWithHoles = __webpack_require__(10);

var iterableToArrayLimit = __webpack_require__(11);

var unsupportedIterableToArray = __webpack_require__(12);

var nonIterableRest = __webpack_require__(14);

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}

module.exports = _slicedToArray;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 6 */
/***/ (function(module, exports) {

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return typeof obj;
    };

    module.exports["default"] = module.exports, module.exports.__esModule = true;
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };

    module.exports["default"] = module.exports, module.exports.__esModule = true;
  }

  return _typeof(obj);
}

module.exports = _typeof;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 7 */
/***/ (function(module, exports) {

function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  module.exports["default"] = module.exports, module.exports.__esModule = true;
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

var setPrototypeOf = __webpack_require__(15);

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

module.exports = _inherits;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

var _typeof = __webpack_require__(6)["default"];

var assertThisInitialized = __webpack_require__(16);

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

module.exports = _possibleConstructorReturn;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 10 */
/***/ (function(module, exports) {

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

module.exports = _arrayWithHoles;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 11 */
/***/ (function(module, exports) {

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

module.exports = _iterableToArrayLimit;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

var arrayLikeToArray = __webpack_require__(13);

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
}

module.exports = _unsupportedIterableToArray;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 13 */
/***/ (function(module, exports) {

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

module.exports = _arrayLikeToArray;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 14 */
/***/ (function(module, exports) {

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

module.exports = _nonIterableRest;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 15 */
/***/ (function(module, exports) {

function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  module.exports["default"] = module.exports, module.exports.__esModule = true;
  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 16 */
/***/ (function(module, exports) {

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

module.exports = _assertThisInitialized;
module.exports["default"] = module.exports, module.exports.__esModule = true;

/***/ }),
/* 17 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "Handler", function() { return /* reexport */ src_Handler; });
__webpack_require__.d(__webpack_exports__, "OutSide", function() { return /* reexport */ src_OutSide; });
__webpack_require__.d(__webpack_exports__, "FocusWithin", function() { return /* reexport */ src_FocusWithin; });

// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/defineProperty.js
var defineProperty = __webpack_require__(1);
var defineProperty_default = /*#__PURE__*/__webpack_require__.n(defineProperty);

// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/slicedToArray.js
var slicedToArray = __webpack_require__(5);
var slicedToArray_default = /*#__PURE__*/__webpack_require__.n(slicedToArray);

// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/classCallCheck.js
var classCallCheck = __webpack_require__(2);
var classCallCheck_default = /*#__PURE__*/__webpack_require__.n(classCallCheck);

// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/createClass.js
var createClass = __webpack_require__(3);
var createClass_default = /*#__PURE__*/__webpack_require__.n(createClass);

// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/inherits.js
var inherits = __webpack_require__(8);
var inherits_default = /*#__PURE__*/__webpack_require__.n(inherits);

// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/possibleConstructorReturn.js
var possibleConstructorReturn = __webpack_require__(9);
var possibleConstructorReturn_default = /*#__PURE__*/__webpack_require__.n(possibleConstructorReturn);

// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/getPrototypeOf.js
var getPrototypeOf = __webpack_require__(7);
var getPrototypeOf_default = /*#__PURE__*/__webpack_require__.n(getPrototypeOf);

// EXTERNAL MODULE: external "React"
var external_React_ = __webpack_require__(0);
var external_React_default = /*#__PURE__*/__webpack_require__.n(external_React_);

// EXTERNAL MODULE: external "ReactDOM"
var external_ReactDOM_ = __webpack_require__(4);

// CONCATENATED MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/src/Handler.ts








function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { defineProperty_default()(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf_default()(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf_default()(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn_default()(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }




/**
 * 获取children的dom ref 同时可以给dom添加react合成事件
 * 原理是劫持了react 的合成事件
 */
var Handler_ClassDomNode = /*#__PURE__*/function (_React$PureComponent) {
  inherits_default()(ClassDomNode, _React$PureComponent);

  var _super = _createSuper(ClassDomNode);

  function ClassDomNode() {
    classCallCheck_default()(this, ClassDomNode);

    return _super.apply(this, arguments);
  }

  createClass_default()(ClassDomNode, [{
    key: "assignmentRef",
    value:
    /**
     * ref 赋值
     */
    function assignmentRef() {
      var node = Object(external_ReactDOM_["findDOMNode"])(this);

      if (node && node instanceof Element) {
        //__reactEventHandlers 是16.8在使用的  __reactProps是17使用的
        var _ref = Object.entries(node).find(function (_ref3) {
          var _ref4 = slicedToArray_default()(_ref3, 1),
              key = _ref4[0];

          return key.startsWith('__reactEventHandlers') || key.startsWith('__reactProps');
        }) || [],
            _ref2 = slicedToArray_default()(_ref, 2),
            key = _ref2[0],
            targetProps = _ref2[1];

        var cloneProps = _objectSpread({}, targetProps);

        var _props = _objectSpread({}, this.props);

        delete _props.__forwardRef;
        delete _props.children;
        Object.entries(_props).forEach(function (_ref5) {
          var _ref6 = slicedToArray_default()(_ref5, 2),
              prop = _ref6[0],
              value = _ref6[1];

          if (value && typeof value !== 'function') {
            console.warn("".concat(prop, " not support"));
          } else if (value) {
            cloneProps[prop] = function () {
              var method = targetProps[prop];

              for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
                params[_key] = arguments[_key];
              }

              method === null || method === void 0 ? void 0 : method.apply(void 0, params);
              value.apply(void 0, params);
            };
          }
        });
        node[key] = cloneProps;
      }

      if (typeof this.props.__forwardRef === 'function') {
        this.props.__forwardRef(node);
      } else {
        this.props.__forwardRef.current = node;
      }
    }
    /**
     *加载完成
     */

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.assignmentRef();
    }
    /**
     * 更新后
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.assignmentRef();
    }
    /**
     *渲染函数
     */

  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return ClassDomNode;
}(external_React_default.a.PureComponent);

var Handler = /*#__PURE__*/Object(external_React_["forwardRef"])(function (props, ref) {
  return /*#__PURE__*/external_React_default.a.createElement(Handler_ClassDomNode, _objectSpread(_objectSpread({}, props), {}, {
    __forwardRef: ref
  }));
});
Handler.displayName = 'Handler';
/* harmony default export */ var src_Handler = (Handler);
// EXTERNAL MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/node_modules/_@babel_runtime@7.13.10@@babel/runtime/helpers/typeof.js
var helpers_typeof = __webpack_require__(6);
var typeof_default = /*#__PURE__*/__webpack_require__.n(helpers_typeof);

// CONCATENATED MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/src/utils/util.tsx
/**
 * 随机生成UUID
 */
function UUID() {
  return 'uuid-xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0,
        v = c === 'x' ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
}
/**
 * 只执行一次fn
 * @param fn
 * @param context
 */

function util_once(fn, context) {
  var result;
  return function () {
    if (fn) {
      for (var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++) {
        params[_key] = arguments[_key];
      }

      result = fn.apply(context || this, params);
      fn = null;
    }

    return result;
  };
}
/**
 * 类似于dom的classList
 */

function classList(dom) {
  var _dom$className;

  var _dom = dom;
  var classes = (dom === null || dom === void 0 ? void 0 : (_dom$className = dom.className) === null || _dom$className === void 0 ? void 0 : _dom$className.trim().split(/\s+/g)) || [];
  return {
    add: function add() {
      for (var _len2 = arguments.length, params = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        params[_key2] = arguments[_key2];
      }

      classes.push(params);
      classes = classes.flat();
      _dom && (_dom.className = classes.join(' ').trim());
    },
    remove: function remove() {
      for (var _len3 = arguments.length, params = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        params[_key3] = arguments[_key3];
      }

      params.forEach(function () {
        var param = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
        var index = classes.indexOf(param);

        if (index !== -1) {
          classes.splice(index, 1);
        }
      });

      if (_dom && classes.length === 0) {
        return _dom.removeAttribute('class');
      }

      _dom && (_dom.className = classes.join(' ').trim());
    },
    toggle: function toggle(token, force) {
      var index = classes.indexOf(token);

      if (index === -1) {
        classes.push(token);
      } else if (!force) {
        classes.splice(index, 1);
      }

      if (_dom && classes.length === 0) {
        _dom.removeAttribute('class');

        return true;
      }

      _dom && (_dom.className = classes.join(' ').trim());
      return true;
    },
    contains: function contains(token) {
      return !!classes.find(function (item) {
        return token === item;
      });
    }
  };
}
// CONCATENATED MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/src/utils/warning.ts
/**
 * 警告
 * @param valid
 * @param component
 * @param message
 * @param node
 */
function warning(valid, component, message, node) {
  // Support uglify
  if (false) {}
}
// CONCATENATED MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/src/utils/event.ts



var event_EventTarget = /*#__PURE__*/function () {
  /**
   * 构造函数
   */
  function EventTarget() {
    classCallCheck_default()(this, EventTarget);

    this.listeners = void 0;
    this.listeners = {};
  }
  /**
   *添加监听
   * @param type
   * @param callback
   */


  createClass_default()(EventTarget, [{
    key: "addEventListener",
    value: function addEventListener(type, callback) {
      if (!(type in this.listeners)) {
        this.listeners[type] = [];
      }

      this.listeners[type].push(callback);
    }
    /**
     *移除监听
     * @param type
     * @param callback
     */

  }, {
    key: "removeEventListener",
    value: function removeEventListener(type, callback) {
      if (!(type in this.listeners)) {
        return;
      }

      var stack = this.listeners[type];

      for (var i = 0, l = stack.length; i < l; i++) {
        if (stack[i] === callback) {
          stack.splice(i, 1);
          return this.removeEventListener(type, callback);
        }
      }
    }
    /**
     *触发监听
     * @param type
     * @param params
     */

  }, {
    key: "dispatchEvent",
    value: function dispatchEvent(type, params) {
      if (!(type in this.listeners)) {
        return;
      }

      var stack = this.listeners[type];

      for (var i = 0, l = stack.length; i < l; i++) {
        stack[i].call(this, params);
      }
    }
  }]);

  return EventTarget;
}();


// CONCATENATED MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/src/OutSide.tsx



function OutSide_ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function OutSide_objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { OutSide_ownKeys(Object(source), true).forEach(function (key) { defineProperty_default()(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { OutSide_ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }







var EVENT_ATTR = ['currentTarget', 'eventPhase', 'bubbles', 'cancelable', 'defaultPrevented', 'isTrusted', 'preventDefault', 'timeStamp', 'type', 'nativeEvent', 'target', 'altKey', 'button', 'buttons', 'clientX', 'clientY', 'ctrlKey', 'getModifierState', 'metaKey', 'movementX', 'movementY', 'pageX', 'pageY', 'relatedTarget', 'screenX', 'screenY', 'shiftKey', 'detail', 'view'];
var OutSide_target = new event_EventTarget();
/**
 * document 事件处理函数
 */

function documentClickHandler(e) {
  OutSide_target.dispatchEvent('click', e);
}

if (!window.__observerDocument__) {
  /**确保只监听一次**/

  /**由于react的合成事件也是监听的document 这里想要让documentClickHandler 必须先于react的合成事件之前就必须先于构造函数之前执行**/
  document.addEventListener('click', documentClickHandler, true);
  /**确保只监听一次**/

  window.__observerDocument__ = true;
}

var OutSideContext = /*#__PURE__*/external_React_default.a.createContext(undefined);
OutSideContext.displayName = 'OutSideContext';

var OutSide_RefRenderFunction = function RefRenderFunction(props, forward) {
  var children = props.children;
  var onFocus = props.onFocus,
      onBlur = props.onBlur,
      onOutSideClick = props.onOutSideClick,
      onClick = props.onClick,
      onMouseEnter = props.onMouseEnter,
      onMouseLeave = props.onMouseLeave,
      _props$triggerTiming = props.triggerTiming,
      triggerTiming = _props$triggerTiming === void 0 ? 'inner' : _props$triggerTiming,
      _props$once = props.once,
      once = _props$once === void 0 ? true : _props$once;

  if (typeof_default()(children) !== 'object') {
    children = /*#__PURE__*/external_React_default.a.createElement("span", null, children);
    warning(false, 'OutSide', '传入的children不是JSX.Element类型的值');
  }

  var context = Object(external_React_["useContext"])(OutSideContext);
  var ins = Object(external_React_["useRef"])({});
  var ref = Object(external_React_["useRef"])(null);

  if (forward) {
    if (forward instanceof Function) {
      var originFn = forward;
      var current;

      ref = function ref(_ref) {
        originFn.bind(this)(_ref);
        current = _ref;
      };

      Object.defineProperty(ref, 'current', {
        get: function get() {
          return Object(external_ReactDOM_["findDOMNode"])(current);
        }
      });
    } else {
      ref = forward;
    }
  }
  /***
   * 组件加载后
   */


  Object(external_React_["useEffect"])(function () {
    if (onOutSideClick || onClick) {
      generateOnce();
      OutSide_target.addEventListener('click', handleCallback);
    }

    return function () {
      OutSide_target.removeEventListener('click', handleCallback);
    };
  }, []);
  /**
   * 生成一次执行函数
   */

  var generateOnce = function generateOnce() {
    /**是否只能点击一次**/
    if (once) {
      ins.current.onceClick = util_once(onOutSideClick);
    }
  };
  /**
   * 处理鼠标进入
   * @param e
   */


  var handleMouseEnter = function handleMouseEnter(e) {
    /**事件确保这里只需要在目标元素执行**/
    if (ref.current && ref.current.contains(e.target)) {
      ins.current.triggerInner = true;
      onMouseEnter && onMouseEnter(e);
    }
  };
  /**
   * 处理鼠标进入
   * @param e
   */


  var handleMouseLeave = function handleMouseLeave(e) {
    /**事件确保这里只需要在目标元素执行**/
    if (ref.current && ref.current.contains(e.target)) {
      onMouseLeave && onMouseLeave(e);
    }
  };
  /**
   * 生成event
   * @param e
   */


  var generateEvent = function generateEvent(e) {
    if (!context) {
      return e;
    }

    var _stopPropagation = context.stopPropagation;
    var _isPropagationStopped = false;
    var event = {
      stopPropagation: function stopPropagation() {
        if (e.stopPropagation) {
          e.stopPropagation();
        }

        _stopPropagation && _stopPropagation();
        _isPropagationStopped = true;
      },
      isPropagationStopped: function isPropagationStopped() {
        return _isPropagationStopped;
      }
    };
    EVENT_ATTR.forEach(function (attr) {
      Object.defineProperty(event, attr, {
        get: function get() {
          /**对这个target属性做特殊处理**/
          if (attr === 'target') {
            return e.target || e.srcElement;
          }

          return e[attr];
        }
      });
    });
    return event;
  };
  /**
   * 处理组价的事件
   */


  var handleCallback = function handleCallback(e) {
    var _ref2 = ref,
        current = _ref2.current;

    if (current) {
      var _style = getComputedStyle(current);

      if (_style.pointerEvents === 'none') {
        warning(false, 'OutSide', '节点的样式 pointerEvents = none 导致onOutSideClick失效', current);
      }
    }
    /**ie中不存在e.target 只有e.srcElement**/


    if (!current.contains(e.target || e.srcElement)) {
      if (triggerTiming === 'outside' || triggerTiming === 'inner' && ins.current.triggerInner) {
        var callback;
        /**是否只执行一次**/

        if (once) {
          /**取出this.onceClick等函数**/
          callback = ins.current.onceClick;
          /**执行this.onceClick等函数**/

          callback && callback(e);
          /**表示当前是没有点击children**/

          ins.current.triggerInner = false;
        } else {
          /**如果不是执行一次那么就使用传下来的callback**/
          !ins.current.isPropagationStopped && onOutSideClick && onOutSideClick(generateEvent(e));
        }
      }
    }
  };
  /**
   *处理内部点击
   * @param e
   */


  var handleInnerClick = function handleInnerClick(e) {
    ins.current.triggerInner = true;
    generateOnce();
    onClick && onClick(e);
  };

  var childProps = OutSide_objectSpread({}, children.props);

  return /*#__PURE__*/external_React_default.a.createElement(OutSideContext.Provider, {
    value: {
      stopPropagation: function stopPropagation() {
        ins.current.isPropagationStopped = true;
      }
    }
  }, /*#__PURE__*/external_React_default.a.createElement(src_Handler, {
    ref: ref,
    onClick: handleInnerClick,
    onFocus: onFocus,
    onBlur: onBlur,
    onMouseEnter: handleMouseEnter,
    onMouseLeave: handleMouseLeave
  }, /*#__PURE__*/external_React_default.a.cloneElement(children, childProps)));
};

var OutSide = /*#__PURE__*/Object(external_React_["forwardRef"])(OutSide_RefRenderFunction);
OutSide.displayName = 'OutSide';
/* harmony default export */ var src_OutSide = (OutSide);
// CONCATENATED MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/src/FocusWithin.tsx





var noop = function noop() {
  return undefined;
};

var stopPropagation = FocusEvent.prototype.stopPropagation;

FocusEvent.prototype.stopPropagation = function () {
  var _this = this;

  this.path.forEach(function (node) {
    if (_this.type === 'blur') {
      node.__onBlur && node.__onBlur();
    } else if (_this.type === 'focus') {
      node.__onFocus && node.__onFocus();
    }
  });

  for (var _len = arguments.length, rest = new Array(_len), _key = 0; _key < _len; _key++) {
    rest[_key] = arguments[_key];
  }

  return stopPropagation.call.apply(stopPropagation, [this].concat(rest));
};
/***
 * 该组件的功能是类似于css伪类:focus-within
 * 即当前组件包裹的children的子组件获得焦点、那么当前组件包裹的children就会添加is-focus类
 */


var FocusWithin_FocusWithin = function FocusWithin(props) {
  var children = props.children,
      disabled = props.disabled,
      _props$focusClassName = props.focusClassName,
      focusClassName = _props$focusClassName === void 0 ? 'is-focus' : _props$focusClassName;
  var ref = Object(external_React_["useRef"])(null);
  Object(external_React_["useEffect"])(function () {
    var keys = Object.keys(props).filter(function (key) {
      return key !== 'children' && key !== 'disabled' && key !== 'focusClassName';
    }).map(function (key) {
      return key + '属性无效，';
    });
    warning(keys.length === 0, 'FocusWithin', keys + 'FocusWithin组件只支持children、disabled、focusClassName属性');

    if (ref.current) {
      var __onFocus = ref.current.__onFocus || noop;

      ref.current.__onFocus = function () {
        handleFocus();
        return __onFocus();
      };

      var __onBlur = ref.current.__onBlur || noop;

      ref.current.__onBlur = function () {
        handleBlur();
        return __onBlur();
      };
    }
  }, []);
  /**
   * 处理聚焦
   */

  var handleFocus = function handleFocus() {
    if (!disabled) {
      var classes = classList(ref.current);

      if (!classes.contains(focusClassName)) {
        classes.add(focusClassName);
      }
    }
  };
  /**
   * 处理失去焦点
   */


  var handleBlur = function handleBlur() {
    if (!disabled) {
      var classes = classList(ref.current);

      if (classes.contains(focusClassName)) {
        classes.remove(focusClassName);
      }
    }
  };

  return /*#__PURE__*/external_React_default.a.createElement(src_Handler, {
    ref: ref,
    onFocus: handleFocus,
    onBlur: handleBlur
  }, children);
};

/* harmony default export */ var src_FocusWithin = (FocusWithin_FocusWithin);
// CONCATENATED MODULE: E:/Soft/JetBrains/WebStorm WorkSpace/react-handler/src/index.ts

/* harmony default export */ var src = __webpack_exports__["default"] = (src_Handler);




/***/ })
/******/ ]);
});