/**
 * 随机生成UUID
 */
export declare function UUID(): string;
/**
 * 只执行一次fn
 * @param fn
 * @param context
 */
export declare function once(fn: (...params: any) => void, context?: any): (...params: any[]) => any;
/**
 * 类似于dom的classList
 */
export declare function classList(dom: Element): Pick<DOMTokenList, 'add' | 'remove' | 'toggle' | 'contains'>;
