"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = warning;

/**
 * 警告
 * @param valid
 * @param component
 * @param message
 * @param node
 */
function warning(valid, component, message, node) {
  // Support uglify
  if (process.env.NODE_ENV !== 'production' && !valid && console !== undefined) {
    if (node) {
      console.warn("Warning: [handler-fragment: ".concat(component, "]"), node, message);
    } else {
      console.warn("Warning: [handler-fragment: ".concat(component, "] ").concat(message));
    }
  }
}